/*****************************************************
  File:        lam_to_dist.c
  Date:        March 9, 1997
  Written by:  Jaya Satagopan (satago@biost.mskcc.org)

  Purpose:
    Convert lambda values to centiMorgan distances.
*****************************************************/

#include "revjump.h"

void lam_to_dist(int nqtl, double *lambda, double *cumdist,
    double *dist, double *lam_dist){

  int iqtl, count, nlam;

  for(iqtl=0;iqtl<nqtl;iqtl++){
    nlam = lambda[iqtl];
    lam_dist[iqtl] = (lambda[iqtl] - nlam) * dist[nlam];
    lam_dist[iqtl] = lam_dist[iqtl] * 100;
    if( nlam >=1 )
      lam_dist[iqtl] = lam_dist[iqtl] + cumdist[nlam];
  }
}
