/*****************************************************
  File:        qtl_prob.c
  Date:        September 8, 1997
  Written by:  Jaya Satagopan (satago@biost.mskcc.org)

  Purpose:
    Update qtl genotypes from Bernoulli probability

*****************************************************/

#include "revjump.h"

/******************************************
        Function QPROB_F1
******************************************/

void qprob_f1(int jobs, int ntrait, int nqtl, int iqtl,
              int qtl_genotype[][MAXQTL], double *y,
              double mu, double *effect, double sigmasq,
              double *qival, double *qprob_val, double *sum_val){
  int igen, kqtl;
  double denominator, work_sum, work_sq, work_val;

  work_sq = -0.5 / sigmasq;
  for(igen=0;igen<2;igen++){
    if(igen==1) work_sum = -effect[iqtl];
    else work_sum = effect[iqtl];

    for(kqtl=0; kqtl<nqtl; kqtl++){
      if(kqtl != iqtl) work_sum = work_sum +
                                  effect[kqtl] * qtl_genotype[jobs][kqtl];
      work_val = y[jobs] - mu - work_sum;
      sum_val[igen] = work_val * work_val;
    }
  }
  denominator = 0.0;
  for(igen=0;igen<2;igen++){
    qprob_val[igen] = qival[igen] * exp(sum_val[igen]*work_sq);
    denominator = denominator + qprob_val[igen];
  }

  if(qprob_val[0] < 0.000001){
    qprob_val[0] = 0.0001;
    denominator = denominator + qprob_val[0];
  }
  for(igen=0;igen<2;igen++){
    qprob_val[igen] = qprob_val[igen] / denominator;
  }
}
