/************************************************************
    File:        select_move.c
    Date:        September 3, 1997
    Written by:  Jaya Satagopan (satago@biost.mskcc.org) 

    Purpose:

      Function SELECT_MOVE selects birth, death or 
      parameter update move.
************************************************************/

#include "revjump.h"

extern float genunf(float, float);

int select_move( int nmark, int nqtl, double qtl_prior_mn, int *nmove ){
  double birth_prob, death_prob, cval, uni_ran;
  int move_type, max_birth;

  birth_prob=0.0;
  death_prob=0.0;
  max_birth = min( (nmark-1), MAXQTL);
  if( nqtl < max_birth ){
    birth_prob = qtl_prior_mn / (nqtl+1);
    if(birth_prob >1) birth_prob = 1.0;
  }
  if( nqtl > 0){
    death_prob = nqtl / qtl_prior_mn;
    if(death_prob >1) death_prob = 1.0;
  }
/*   cval = genunf(0.0, 0.5);  */
  cval = 0.4;
  birth_prob = cval * birth_prob;
  death_prob = cval * death_prob;

  uni_ran = genunf(0.0, 1.0);
  if( uni_ran < birth_prob){
    move_type =1;
    nmove[0] = nmove[0]+1;
  }
  else{
    if( uni_ran < (birth_prob+death_prob) ){
      move_type = 2;
      nmove[2] = nmove[2]+1;
    }
    else{
	move_type=3;
	nmove[4] = nmove[4] + 1;
/*        nmove[2][0] = nmove[2][0]+1; */
    }
  }
  return move_type;
}
