/***************************************************
  File:        setvals.c
  Written by:  Jaya M. Satagopan (satago@biost.mskcc.org)
  Date:        October 15, 1997

  Purpose:

    Reset the model parameters and qtl genotypes after
    the birth step is accepted
***************************************************/

#include "revjump.h"

void setvals(int ntrait, int *nqtl, 
	     double *mu, double *effect, double *lambda,
	     double *modified_parms, double new_position,
	     int qtl_genotype[][MAXQTL], int *new_qtl_genotype){

  int jobs, iqtl, kqtl, temp_nqtl;
  /*
  double *temp_effect = (double *) malloc(MAXQTL *sizeof(double));
  double *temp_lambda = (double *) malloc(MAXQTL *sizeof(double));

  for(iqtl=0; iqtl<*nqtl; iqtl++){
    temp_effect[iqtl] = modified_parms[iqtl];
    temp_lambda[iqtl] = lambda[iqtl];
  }
  */

  if(new_position > lambda[*nqtl-1]){
    lambda[*nqtl] = new_position;
    effect[*nqtl] = modified_parms[*nqtl+1];
    for(jobs=0;jobs<ntrait;jobs++){
      qtl_genotype[jobs][*nqtl] = new_qtl_genotype[jobs];
    }
  }
  else{
    if(new_position < lambda[0]){
      for(iqtl=*nqtl; iqtl>=1; iqtl--){
	lambda[iqtl] = lambda[iqtl-1];
	effect[iqtl] = effect[iqtl-1]; 
	for(jobs=0;jobs<ntrait;jobs++)
	  qtl_genotype[jobs][iqtl] = qtl_genotype[jobs][iqtl-1];
      }
      lambda[0] = new_position;
      effect[0] = modified_parms[*nqtl+1];
      for(jobs=0;jobs<ntrait;jobs++)
	qtl_genotype[jobs][0] = new_qtl_genotype[jobs];
    }
    else{
      for(iqtl=1;iqtl<*nqtl;iqtl++){
	if( (lambda[iqtl-1] < new_position) &&
	    (new_position < lambda[iqtl]) ){
	  for(kqtl=*nqtl; kqtl>iqtl;kqtl--){
	    lambda[kqtl] = lambda[kqtl-1];
	    effect[kqtl] = effect[kqtl-1];
	    for(jobs=0;jobs<ntrait;jobs++)
	      qtl_genotype[jobs][kqtl] = qtl_genotype[jobs][kqtl-1];
	  }
	  lambda[iqtl] = new_position;
	  effect[iqtl] = modified_parms[*nqtl+1];
	  for(jobs=0;jobs<ntrait;jobs++)
	    qtl_genotype[jobs][iqtl] = new_qtl_genotype[jobs];

        }
      }
    }
  }

  *mu = modified_parms[0];
  *nqtl = *nqtl + 1;
}
