/*****************************************************
  File:        update_qtl.c
  Date:        September 8, 1997
  Written by:  Jaya Satagopan (satago@biost.mskcc.org)

  Purpose:
    Update qtl genotypes from Bernoulli probability

*****************************************************/

#include "revjump.h"

extern float genunf(float, float);
extern void which_marker(int, int, int, int *, int *, int, double *,
    double *, int, int, int *);
extern void qprob_f1(int, int, int, int, 
		     int *, double *, double, double *, double,
		     double *, double *, double *);

/********************************************
        Function UPDATE_QTL_GENO
********************************************/
void update_qtl_geno(int ntrait, int nqtl, int nmark, int iqtl,
                     int flank_left, int flank_right,
                     int marker_genotype[][MAXMARKER],
                     double r1_old, double R_old, int dist_old,
                     double *lambda, double *new_lambda, double *y,
                     double mu, double *effect, double sigmasq,
                     int qtl_genotype[][MAXQTL], double *sum_val,
		     int *markers, double *qival, double *qprob_val){
  int j, old_mark1, old_mark2;
  double uni_ran;
/*
  int *markers = (int *) malloc(2*sizeof(int));
  double *qival = (double *) malloc(2*sizeof(double));
  double *qprob_val = (double *) malloc(2*sizeof(double));
*/

  for(j=0; j<ntrait; j++){
    if( nqtl==1 ){
      old_mark1 = marker_genotype[j][dist_old];
      old_mark2 = marker_genotype[j][dist_old+1];
    }
    else{
      which_marker(iqtl, j, nqtl, &marker_genotype[0][0],
                             &qtl_genotype[0][0], dist_old,
                             &lambda[0], &new_lambda[0], flank_left,
                             flank_right, &markers[0]);
      old_mark1 = markers[0];
      old_mark2 = markers[1];
    }
    f1_prob( old_mark1, old_mark2, r1_old, R_old, &qival[0]);
    qprob_f1(j, ntrait, nqtl, iqtl, &qtl_genotype[0][0], &y[0],
             mu, &effect[0], sigmasq, &qival[0], &qprob_val[0],
	     &sum_val[0]);
    uni_ran = genunf(0.0,1.0);
    qtl_genotype[j][iqtl] = random_marker(uni_ran, qprob_val[0]);
  }
}
