/*****************************************************
  File:        which_marker.c
  Date:        September 8, 1997
  Written by:  Jaya Satagopan (satago@biost.mskcc.org)

  Purpose:
    Calculate the metropolis-hastings acceptance
    probability for lambda versus new_lambda.
    Return whichever value of lambda is accepted.
*****************************************************/

#include "revjump.h"

extern float genunf(float,float);

/*****************************************
        Function WHICH_MARKER
*****************************************/
void which_marker(int iqtl, int j, int nqtl,
                  int marker_genotype[][MAXMARKER],
                  int qtl_genotype[][MAXQTL], int dist_new,
                  double *lambda, double *new_lambda,
                  int flank_left, int flank_right, int *markers){

  if( flank_left == flank_right ){
    if( iqtl == 0 ){
      if( nqtl == 1 ){
        if( new_lambda[iqtl] < lambda[iqtl] ){
          markers[0] = marker_genotype[j][dist_new];
          markers[1] = qtl_genotype[j][iqtl];
        }
        else{
          markers[0] = qtl_genotype[j][iqtl];
          markers[1] = marker_genotype[j][1+dist_new];
        }
      }
      else{
        if( new_lambda[iqtl] < lambda[iqtl+1] ){
          markers[0] = marker_genotype[j][dist_new];
          markers[1] = qtl_genotype[j][iqtl+1];
        }
        else{
          markers[0] = qtl_genotype[j][iqtl+1];
          markers[1] = marker_genotype[j][1+dist_new];
        }
      }
    }
    else{
      if( new_lambda[iqtl] < lambda[iqtl-1] ){
        markers[0] = marker_genotype[j][dist_new];
        markers[1] = qtl_genotype[j][iqtl-1];
      }
      else{
        markers[0] = qtl_genotype[j][iqtl-1];
        markers[1] = marker_genotype[j][1+dist_new];
      }
    }
  }
  else{
    markers[0] = marker_genotype[j][dist_new];
    markers[1] = marker_genotype[j][1+dist_new];
  }
}
